#include "Def.h"

Fire::Fire() {};

void Fire::init(int nx, int ny)
{
	origx = nx;
	origy = ny;
	
	x = nx + (rand() % 20) - 10;
	y = ny;
	dx = (rand() % 80) - 40;
	dy = 10 - (rand() % 150);
	biasx = +15;
	biasy = -40;
	life = ((float)(rand() % 20)) / 10.0;
	generation = 10;
	speed_dampener = .3; 
	black = 2;
	orange = 10;
	yellow = 18;
} 

void Fire::update(float delapsed)
{
	x += (dx + biasx) * delapsed;
	y += (dy + biasy) * delapsed;
	dx = dx * (1 - speed_dampener * delapsed);
	dy = dy * (1 - speed_dampener * delapsed);
	life = life - delapsed;
	black += 20 * delapsed;
	orange -= 2 * delapsed;
	yellow -= 30 * delapsed;
	
} 

void Fire::draw(BITMAP* buff)
{
	if(generation <= 0)
		return;
	if(life > 0)
	{   
		if(black > 20 && black < 60)
			circlefill(buff, (int)x, (int)y, (int)black, makecol((int)black,(int)black,(int)black));//black
		if(orange > 8.3)
			circlefill(buff, (int)x + 1, (int)y, (int)orange, makecol(255, 168, 0));//orange
			if(yellow > 5)
				circlefill(buff, (int)x, (int)y + 1, (int)yellow, makecol(255, 255, 0));//yellow     
				return;
	}
	x = origx + (rand() % 20) - 10;
	y = origy;
	dx = (rand() % 80) - 40;
	dy = (-10) - (rand() % 100);
	biasx = +15;
	biasy = -40;
	life = ((float)(rand() % 30)) / 10.0;
	speed_dampener = .3; 
	generation--;
	black = 2;
	orange = 10;
	yellow = 20;
}
