
#include "Def.h"

int splash()
{
    setupBuffer();
    clear_to_color(buffer, makecol(0, 0, 0));
    
    rectfill(buffer, 317, 58, 443, 70, makecol(50, 50, 100));
    rect(buffer, 316, 57, 444, 71, makecol(128, 128, 0));
    rect(buffer, 315, 56, 445, 72, makecol(200, 200, 64));
    rect(buffer, 314, 55, 446, 73, makecol(255, 255, 128));
    textout_ex(buffer, font, "TO LIVE IN FEAR", 320, 61, makecol(200, 200, 0), -1);
    textout_ex(buffer, font, "A game of tragic survival in Africa and Darfur", 210, 79, makecol(200, 200, 0), -1);
    textout_ex(buffer, font, "TINS '07 Entrant", 317, 92, makecol(200, 200, 0), -1);

    textout_ex(buffer, font, "Programming - Robert Muller", 290, 112, makecol(200, 200, 200), -1);
    textout_ex(buffer, font, "Additional Programming - Chris O'Neill", 290, 123, makecol(200, 200, 200), -1);

    textout_ex(buffer, font, "*Object: survive as long as possible, ", 100, 200, makecol(200, 200, 200), -1);
    textout_ex(buffer, font, "if you run out of strength and hydration, you die", 120, 210, makecol(200, 200, 200), -1);
    textout_ex(buffer, font, "*Controls: Left/Right arrows, Enter, and Esc", 100, 230, makecol(200, 200, 200), -1);
    textout_ex(buffer, font, "*NOTE: The 'Cook' action allows you to increase the ", 100, 250, makecol(200, 200, 200), -1);
    textout_ex(buffer, font, "amount of strength and hydration you get from food.", 120, 260, makecol(200, 200, 200), -1);
    copyBuffer();
    readkey();
    return 1;
};

int begin_game()
{
    clear_keybuf();
    rest(200);
    
    int moves = 0;
    bool aheld = false;
    bool rheld = false;
    bool lheld = false;
    bool eheld = false;
    Scene darfur;
    Survivor you;
    SAMPLE *sample = load_sample("blip.wav");
    SAMPLE *move = load_sample("move.wav");
    
    while(!key[KEY_ESC])
    {
        setupBuffer();
        darfur.draw(buffer);
        you.draw(buffer);
        poll_keyboard();
        
        if(!aheld && key[KEY_A])
        {
            darfur.resetFire();
            aheld = true;
        }
	else if (!key[KEY_A])
	{
		aheld = false;
	}

        if(!rheld && key[KEY_RIGHT])
        {
            if(you.option(true))
                play_sample(move, 128, 128, 1000, 0);
            rheld = true;
        }
	else if (!key[KEY_RIGHT]) 
	{
		rheld = false;
	}
	
        if(!lheld && key[KEY_LEFT])
        {
            if(you.option(false))
                play_sample(move, 128, 128, 1000, 0);
            lheld = true;
        }
	else if (!key[KEY_LEFT]) 
	{
		lheld = false;
	}
	
	if(!eheld && key[KEY_ENTER])
        {
            play_sample(sample, 255, 128, 1000, 0);
            if(you.option() == 4 && you.haswood())
                darfur.resetFire();
            //you.activate();
            if(you.activate())
            {
                copyBuffer();

                return moves;
            }
            eheld = true;
            moves++;
            if(rand() % moves > 15)
                return (moves * -1);
        }
	else if (!key[KEY_ENTER]) 
	{
		eheld = false;
	}
        
     
        rest(20);
        copyBuffer();
    }
    return 0;
  

};


void end(int endnumber)
{
    setupBuffer();
        clear_to_color(buffer, makecol(0, 0, 0));
    if(endnumber >= 0)
    {
    textprintf_ex(buffer, font, 10, 100, makecol(255, 60, 60), -1, "You died of starvation/dehydration and survived for %i turns", endnumber);
    }
    if(endnumber < 0)
    {
    textprintf_ex(buffer, font, 10, 100, makecol(255, 60, 60), -1, "You were captured & brutaly murdered by the janjaweed and survived for %i turns", (int)(endnumber * -1));
    }
    textout_ex(buffer, font, " \"Survival in Darfur is like winning, ", 210, 150, makecol(255, 60, 60), -1);
    textout_ex(buffer, font, "except in the end your still stuck in the same $#@% hole.\"", 150, 161, makecol(255, 60, 60), -1);
    textout_ex(buffer, font, "-programmer of this game", 270, 175, makecol(255, 60, 60), -1);
    textout_ex(buffer, font, "please visit any of the following sites to learn more about the suffeing in Dafur, Africa.", 20, 265, makecol(255, 255, 255), -1);
    textout_ex(buffer, font, "www.savedarfur.org/", 30, 300, makecol(200, 200, 0), -1);
    textout_ex(buffer, font, "www.darfurgenocide.org/", 30, 325, makecol(200, 200, 0), -1);
    textout_ex(buffer, font, "www.darfurisdying.com/ ", 30, 350, makecol(200, 200, 0), -1);
    textout_ex(buffer, font, "(Please note that ALL similarities between this flash game and mine are coincidental. ", 30, 360, makecol(128, 128, 128), -1);
    textout_ex(buffer, font, "I was informed of this site by a friend only 14 hours before completing the game. ", 30, 370, makecol(128, 128, 128), -1);
    textout_ex(buffer, font, "Although there many similar concepts, my game is still crap. I urge you to play theirs.)", 30, 380, makecol(128, 128, 128), -1);

    copyBuffer();
    rest(1000);
    clear_keybuf();
    readkey();
   return;
};

int main(void)
{
    setup();  
  
    splash();
    end(begin_game());


    return 0;
}

END_OF_MAIN()
